package br.ufes.nemo.seon.ontoloyasservice.generator.lib;

import br.ufes.nemo.seon.ontoloyasservice.oaas.Entity;
import com.google.common.collect.Iterables;
import com.google.inject.Inject;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.naming.IQualifiedNameProvider;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;

@SuppressWarnings("all")
public class FeatureGenerator extends AbstractGenerator {
  @Inject
  @Extension
  private IQualifiedNameProvider _iQualifiedNameProvider;
  
  private String PATH_LIB_FEATURE = "lib/src/";
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<Entity> _filter = Iterables.<Entity>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Entity.class);
    for (final Entity e : _filter) {
      {
        String _lowerCase = this._iQualifiedNameProvider.getFullyQualifiedName(e).toString("/").toLowerCase();
        String _plus = (((this.PATH_LIB_FEATURE + "features") + "/") + _lowerCase);
        String _plus_1 = (_plus + ".feature");
        fsa.generateFile(_plus_1, 
          this.feature(e));
        String _lowerCase_1 = this._iQualifiedNameProvider.getFullyQualifiedName(e).toString("/").toLowerCase();
        String _plus_2 = ((this.PATH_LIB_FEATURE + "features/steps/") + _lowerCase_1);
        String _plus_3 = (_plus_2 + ".py");
        fsa.generateFile(_plus_3, 
          this.step(e));
      }
    }
  }
  
  public CharSequence feature(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("Feature: Commmon Cases of ");
    String _name = e.getName();
    _builder.append(_name);
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("Scenario: Create a ");
    String _name_1 = e.getName();
    _builder.append(_name_1, "    ");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("Given a organization with  ");
    String _name_2 = e.getName();
    _builder.append(_name_2, "    ");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("When i request all ");
    String _name_3 = e.getName();
    _builder.append(_name_3, "    ");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("Then i get a list of ");
    String _name_4 = e.getName();
    _builder.append(_name_4, "    ");
    _builder.append("s");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("    ");
    _builder.append("#Fail test - just testing if the organization is wrong");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("Scenario: fail get all ");
    String _name_5 = e.getName();
    _builder.append(_name_5, "    ");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("Given a false organization with  ");
    String _name_6 = e.getName();
    _builder.append(_name_6, "    ");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("Then i fail in get a list of ");
    String _name_7 = e.getName();
    _builder.append(_name_7, "    ");
    _builder.append("s");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence step(final Entity e) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("from jira_sro_etl import factories");
    _builder.newLine();
    _builder.append("from behave import given, when, then");
    _builder.newLine();
    _builder.newLine();
    _builder.append("global data");
    _builder.newLine();
    _builder.append("global ");
    String _name = e.getName();
    _builder.append(_name);
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("@given(u\'a organization with  ");
    String _name_1 = e.getName();
    _builder.append(_name_1);
    _builder.append("\')");
    _builder.newLineIfNotEmpty();
    _builder.append("def step_impl(context):");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("global data");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("user = \"<USER>\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("apikey = \"<TEXT>\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("server =  \'<URL>");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("#Stairway to heaven project");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("data = {");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("\'user\': user,");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("\'key\': apikey,");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("\'url\': server");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.append("@when(u\'When i request all ");
    String _name_2 = e.getName();
    _builder.append(_name_2);
    _builder.append("\')");
    _builder.newLineIfNotEmpty();
    _builder.append("def step_impl(context):");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("global ");
    String _name_3 = e.getName();
    _builder.append(_name_3, "    ");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    String _name_4 = e.getName();
    _builder.append(_name_4, "    ");
    _builder.append(" = factories.");
    String _name_5 = e.getName();
    _builder.append(_name_5, "    ");
    _builder.append("Factory()");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.newLine();
    _builder.append("@then(u\'i get a list of ");
    String _name_6 = e.getName();
    _builder.append(_name_6);
    _builder.append("s\')");
    _builder.newLineIfNotEmpty();
    _builder.append("def step_impl(context):");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("assert ");
    String _name_7 = e.getName();
    _builder.append(_name_7, "    ");
    _builder.append(".do(data)");
    _builder.newLineIfNotEmpty();
    _builder.newLine();
    _builder.append("#------Fail-----");
    _builder.newLine();
    _builder.append("@given(u\'a false organization with  ");
    String _name_8 = e.getName();
    _builder.append(_name_8);
    _builder.append("\')");
    _builder.newLineIfNotEmpty();
    _builder.append("def step_impl(context):");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("global data");
    _builder.newLine();
    _builder.append("    ");
    String _name_9 = e.getName();
    _builder.append(_name_9, "    ");
    _builder.append(" = \"<EMAIL>\"");
    _builder.newLineIfNotEmpty();
    _builder.append("    ");
    _builder.append("apikey = \"<KEY>\"");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("server =  \'<Serer>");
    _builder.newLine();
    _builder.append("    ");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("data = {");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("\'");
    String _name_10 = e.getName();
    _builder.append(_name_10, "        ");
    _builder.append("\': ");
    String _name_11 = e.getName();
    _builder.append(_name_11, "        ");
    _builder.append(",");
    _builder.newLineIfNotEmpty();
    _builder.append("        ");
    _builder.append("\'key\': apikey,");
    _builder.newLine();
    _builder.append("        ");
    _builder.append("\'url\': server");
    _builder.newLine();
    _builder.append("    ");
    _builder.append("}");
    _builder.newLine();
    _builder.newLine();
    _builder.append("@then(u\'i fail in get a list of ");
    String _name_12 = e.getName();
    _builder.append(_name_12);
    _builder.append("s\')");
    _builder.newLineIfNotEmpty();
    _builder.append("def step_impl(context):");
    _builder.newLine();
    _builder.append("   ");
    _builder.append("try:       assert ");
    String _name_13 = e.getName();
    _builder.append(_name_13, "   ");
    _builder.append(".do(data)");
    _builder.newLineIfNotEmpty();
    _builder.append("   ");
    _builder.append("except Exception as e:");
    _builder.newLine();
    _builder.append("       ");
    _builder.append("pass");
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    _builder.newLine();
    return _builder;
  }
}
